           .                                          
          .`        `                                 
          ,      `:.                                  
         `,`    ,:`                                   
         .,.   :,,                                    
         .,,  ,,,                                     
    .    .,.:::::  ````                                 :::::::::     :::::::::
    ,`   .::,,,,::.,,,,,,`;;                      .:    ::::::::::    :::    :::
    `,.  ::,,,,,,,:.,,.`  `                       .:    :::      :::  :::     :::
     ,,:,:,,,,,,,,::.   `        `         ``     .:    :::      :::  :::     :::
      ,,:.,,,,,,,,,: `::, ,,   ::,::`   : :,::`  ::::   :::      :::  :::    :::
       ,:,,,,,,,,,,::,:   ,,  :.    :   ::    :   .:    :::      :::  :::::::
        :,,,,,,,,,,:,::   ,,  :      :  :     :   .:    :::      :::  :::::::::
  `     :,,,,,,,,,,:,::,  ,, .::::::::  :     :   .:    :::      :::  :::     :::
  `,...,,:,,,,,,,,,: .:,. ,, ,,         :     :   .:    :::      :::  :::     :::
    .,,,,::,,,,,,,:  `: , ,,  :     `   :     :   .:    :::      :::  :::     :::
      ...,::,,,,::.. `:  .,,  :,    :   :     :   .:    :::::::::::   :::     :::
           ,::::,,,. `:   ,,   :::::    :     :   .:    :::::::::     ::::::::::
           ,,:` `,,.                                  
          ,,,    .,`                                            MULTI-MODEL
         ,,.     `,                                       GRAPH DOCUMENT DATABASE
       ``        `.                                         
                 ``                                          COMMUNITY EDITION
                 `                                             orientdb.com


This document contains the last changes of OrientDB Community Edition.



-----------------------------------------------------------------------------------------------------------------------------------
version 3.2.45 - (October, 22 2025)
- release notes: https://github.com/orientechnologies/orientdb/wiki/orientdb-3.2-release-notes#3245---22-October-2025

# Core
- Changed static thread local allocation after failure due to jdk update
- Correct records size after update and delete
- Fix scheduling of task in past

# Remote
- Correct the use of serializer in network message, issue #10585



-----------------------------------------------------------------------------------------------------------------------------------
version 3.2.44 - (September, 3 2025)
- release notes: https://github.com/orientechnologies/orientdb/wiki/orientdb-3.2-release-notes#3245---3-September-2025

# Core
- Updated commons-lang 2.6 dependency which is obsolete and unsupported
- Correct disk cache size tracking.
- Make sure to not mark document dirty if setting a property to exactly the same simple value, issue #10514
- Correct array handling in polyglot script executor, issue #10532
- Correct class cast exception on index query lookup: issue #10530


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.43 - (August, 7 2025)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3243---7-August-2025

# Core

- Fix tracking of nested queries called by functions or scripts
- Add tracing support to scheduled executor services
- Eliminate duplicate schedule task code

# Distributed

- Minor consistency fixes in embedded DB create/open input validation
- Detect distributed setup early in activate process
- Detect when distributed plugin startup is complete
- Reliably detect distributed plugin enabled
- Guard distributed database open actions

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.42 - (July, 4 2025)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3242---4-July-2025


# Remote

- Fix is of session renew loop based on monotonic time 

# Distributed
- make sure to cancel promises of failed DDLs


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.41 - (June, 18  2025)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3241---18-June-2025


# Core
- Fix synchronization on register and unregister of legacy listener APIs

# Server
- Minor fix in push manager concurrent subscribes and unsubscribes

# Client
- Increase logging in response handling
- Make sure to terminate the push subscribe connection if fails to connect
- simplified the returning of connection from push client


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.40 - (May, 30  2025)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3240---30-May-2025

# Core
- Fix remove of linked class in schema
- Fix views to indexed fields in original ordering, to guarantee index uses in views queries
- Avoid concurrent access to schema on database load
- Avoid double to float casting when loose precision, issue #10391
- Make sure to delete tree RidBag data when converting them to embedded
- Fix use of composite index fields in case of range operations, issue #10456

# Server
- Fixed disconnect push session in case of push error, issue #10453

# Client
- Increased logging in client in case of push execution failure

# Distributed
- Log cluster names in debug only
- Make sure to rollback distributed promise in case of DDL failure

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.39 - (April, 15  2025)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3239---15-April-2025

# Studio

- Used new source for download demo databases

# Core
- Correct wrong usage of snapshot schema in query engine
- Used monotonic time for token validation

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.38 - (February, 20 2025)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3238---20-February-2025

# Core
- Re-implemented update remove with condition, issue #10385
- Make sure to skip null key on index rebuild if are ignored by the index type, issue #10367
- Make sure to return a valid value also for missing property in sequences recyclable flag, issue #10375
- Deprecated long legacy async mode
- Minor optimization in the parser logic

# Distributed 
- Add grace period for distributed database open
- Removed cluster check in distributed configuration not needed anymore
- Minor fix in distributed error message
- Make sure to check all available servers for database online on create
- Make sure to set the database online only when present and active, issue #10386
- Skip the health check if the database is on sync, issues #10383, #10386


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.37 - (Jennuary, 15 2026)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3237---16-Jennaury-2025

# Core
- Make sure to interpret sql script line by line
- Improvement query with target a variable
- Increased cases where pattern matching with loops can be executed correctly
- Deprecated legacy pool implementations

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.36 - (November, 28 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3236---28-November-2024


# Core
- Make sure to correctly evaluate return statements in insert and update statements
- Correct rename of cluster to use every time lower case for low level structures
- Re-add support for '&&' operator for lucene geo overlap operations in the new query engine
- Removed multiple records load when checking if a result is a element
- Handled correctly in condition with collections of collections, issue #10303
- Re-add support of @type, @size record attributes and fixed @version, issue #10332
- Minor fix in script executor retry logic

# Remote 
- make sure to refresh the version of the in context record in the client when updated with a server side query


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.35 - (October, 29 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3235---29-October-2024


# Core

- Corrected regression of support of fetch plans in the function toJson in query engine 
- Make sure to allow dot notation and square brackets for aggregation functions in query engine 
- Minor fix on index creation query to allow not case sensitive collate names
- Avoid to use index with partial range for indexes not supporting null values
- Add support of comparison operators other than equal in chained indexes 
- Block insert of edges with insert operations
- Auto convert properties with map value to documents when specified in the schema
- Corrected create link statement to support link to class

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.34 - (October, 1 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3234---01-October-2024

# Core

- deprecated some record methods that will be remove next version
- Fix handling of group by without aggregations
- Avoid internal double close of result sets
- Fix traverse with variables usages
- Fix use of index on graph in and out collections
- Fix in storage count implementation
- Fix avoid to create new instance of ODocument in query engine for existing records, issue #10268

# Distributed

- Make sure run the distributed transaction expiry task.

# Console

- Support debug mode on all console exceptions.


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.33 - (August, 29 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3233---29-August-2024

# Core

- Marked methods deprecated for removal in the next major
- Make sure to handle record with missing id (lightweight edges) in delete query, issue #10239
- Re-add support of indexes for between queries in new query engine
- Return every time the correct document instance in APis and queries, issue #10280
- Re-add fetch from variable for traverse in the new query engine implementation, issue #10281
- Avoid to use index when the condition is empty list
- Make sure to respect sorting on IN conditions with indexed fields
- Handle correctly lightweight edges in save
- Support of indexes in 'is null' operator
- Corrected ORestricted case for count operations in new query engine


# Graph

- Make sure to bind g variable for groovy-gremlin scripts


# Server

- Update the root password if env variable is set, issue #10273


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.32 - (July, 18 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3232---18-July-2024

# Core

- Fix bug in SQL engine variable name resolution
- Keep order for asSet() function
- Minor optimization in query engine class/cluster filtering
- Make sure to load record from database all the times by query engine
- Make sure that toJson of list of ids get expanded, issue #10264

# Lucene

- Fix IndexReader ref leak when Lucene index modified and read in transaction

# Security Module

- Removed copied code in favor of dependency

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.31 - (June, 19 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3231---19-June-2024

# Core

- Reduced logging for block size detecting
- Add support of empty array as from target of query
- Make sure to run let query every record when there is a context variable
- Make sure to be able to start and load databases on startup also when not run in distributed mode

# Tools

- Add skipping of failed record on import, improved import logging add content of failed record
- Corrected parsing of rid to allow white space around it in import
- Corrected imported to avoid to terminate in case of failure to read a record

# Distributed

- Make sure to retry to install the database later if it fail to install the first time

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.30 - (May, 24 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3230---24-May-2024

# Core
- Fix disk compatiblity on some specific CPU architectures

# Tool
- Add Support of preserving record ids on database import

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.29 - (March, 6 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3229---06-March-2024

# Core
- Fix issue on delegated records on raw access, issue #10171
- Minor fix in transaction not document record handling
- Make sure to check the security policy record exists before creating instance

# Distributed
- Correct id swap revert in distributed transaction during retry
- Make sure to execute full sync in case of delta sync failure

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.28 - (February, 21 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3228---21-February-2024


# Core
- Check if the index exists before checking it's properties
- Make sure to initialize maps on update of value in query engine
- Add name to the OrientDB internal timer
- Removed optimization in query engine that cause failing to update linked records, issue #10077
- Corrected query with content of nested JSON documents to use embedded class
- Add count on the create link result set
- Make sure to call on drop on database drop
- Double Write Log is fsynced on writes. Looks like usage of SYNC flag is not enough
- Double Write Log is not truncated on file flush but only if it reaches file limit
- Double Write Log is truncated every time there are tail segments in queue
- We do not need to make fsync during Write Ahead Log truncation it will be forced by  Double Write Log itself
- sync flag is removed for Double Write Log channel because we perform sync on data write
- Dirty counter is updated on write sync

# Distributed
- Fixed database sync with enterprise agent

# Etl
- Fix concurrent issues in not x86 architectures

# Client
- removed duplicate cancel from client code


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.27 - (January, 26 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3227---26-January-2024

# Core
- Minor correction on value conversion for comparison in queries
- Corrected implementation of tracing executor to trace source properly
- Minor fix on storage open failure
- Correct set of target class when query target a cluster

# Client
- Minor fix on retrying next host from client

# Distributed
- make sure to ignore empty response from distributed requests
- Refactor distributed configuration management to be handled by distributed context 

# Server
- Minor fix on wait for shutdown

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.26 - (January, 9 2024)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3226---9-January-2024


# Core

 - Corrected order by with database locale
 - Used the correct property name in alter property statement propagation
 - Make sure that old query engine use public schema API for create property
 - Re-enabled tests for bonsai tree with fixes
 - Simplification of index implementation in storage and lucene
 - Introduced executor for tracking submitter in case of exception
 - Simplification and optimization in query engine results
 - Corrected insert content query to respect default values

# Distributed
 - Report DDL query errors in distributed correctly
 - Make sure the distributed index drop works in the same way of embedded
 - Minor change in configuration reading on context initialization

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.25 - (November, 30 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3225---30-November-2023

# Core
 - Add support of @fieldTypes in the json from new query engine
 - Add support for multiple json or parameter in insert content in the query engine

# Lucene 
 - Correct lucene search on class function
 - Fix query engine integration with geospatial lucene

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.24 - (October, 26 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3224---26-October-2023

# Core

 - Optimized OResult to load records lazily
 - Optimized OResult to avoid early load of link in properties
 - Minor optimizations in the query engine runtime 
 - Fix insert into index step to use the right value
 - Minor dependencies updates
 - Fix regression in rid comparison in case of embedded query
 - Fix regression in direct insert into index query
 - Fix regression in update index step
 - Avoid storage to go in read only mode if index key type validation fails

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.23- (September, 21 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3223---21-September-2023

# Core
 - Optimization to avoid load record from indexes that do not match the target class
 - Correct delete query in new query engine to consider also binary record
 - Avoid to create temporary records in query engine equal operator
 - Correct the delete edge with single from or to
 - Correct optimization of count queries, issue #10021
 - Moved logic for truncate cluster to the database layer
 - Avoid to scan all the database files for identify a database, issue #10024
 - Add check to avoid to try lock not existing ridbags

# Remote
 - Avoid to cast to the underlying specific type while reading a ridbag from the network, issue #9499
 - Minor fix for lookup of remote session from thread local

# Lucene
 - Make sure that lucene functions do no fail when no class is defined

# Distributed
 - Correct distributed metadata query

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.22 - (August, 17 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3222---17-August-2023

## Core 
 - Optimizations of escaping in serialization of json strings
 - Avoid to store in result metadata not network serializable values, issue #10004
 - Re-enable transaction methods in scripts issue #9690
 - Optimization index rebuild with transactions
 - Minor optimization in free space map logic
 - Fix space reuse, only use spaces in pages that have enough of it, issue #10005 

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.21 - (July, 25 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3221---25-July-2023

## Core
 - Make sure to reload correctly view index informations on context restart
 - Changed logic for tracking the cluster and index views in the queries
 - Optimized view refresh using batch transactions
 - use everytime the most specific index when multiple are found
 - Update build dependencies to most recent versions

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.20 - (June, 15 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3220---15-June-2023

## Core

- Refactor in query engines for execution simplification
- Corrected failure to wait for migration when storage is reused, issue #9974
- Made last refresh time of views persistent
- Minor fix in views to skip refresh of deleted views

## Distributed

- Reduced logging logic that is not used anymore
- Inverted order of finish check for chunks to avoid leaving data in the buffer, issue #9985


## Client
- Make sure that client executor pool size never have size 0


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.19 - (May, 11 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3219---11-May-2023

# Changes

## Core

- Correct the class for scanning vertex on graph repair, issue #9970
- Reduced some dependencies from external libraries
- Removed not needed implementations in native logic
- Removed the need to load a native library to check some system settings
- Moved sources in main modules to avoid split packages, issue #8001
- Minor fix for new internal experimental configuration store
- Revert upgrade of minor dependency that cause issues on older OS
- Minor fixes from static analisys
- Make sure to unblock other storage open operations only when migration is complete, issue #9974

## Distributed

- Deduplication and semplification of distributed logic
- Removed operation waiting flow not needed anymore
- Avoid startup failure in case of rebalancing failure
- Avoid that failure on load of database block the server starting
- Add command to fetch distributed configuration from SQL



-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.18 - (April, 13 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3218---13-April-2023

# Changes

## Core
- Add a specific executor, for all the io operations
- Make sure to use the context executor for all background ops
- Fix automatically remove null links on write of embedded ridbags, issue #9767
- Make sure to use the plugin class loader to load the plugin class
- Avoid repeated distributed database shutdowns
- Fix race in registering installing database to guard against concurrent installs
- Upgrated dependencies
- Minor fix on embedded storage reload
- Increased separation of schema logic for remote and embedded cases


## Remote
- Corrected edge iteration in remote after commit, with relative test case issue #9805

## Gremlin
- Upgrated to the last release of gremlin libraries

## Agent
- Removed not needed dependencies, to reduce the agent bundle size


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.17 - (March, 9 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3217---9-March-2023

# Changes

## Core 
- update dependencies 
- make sure to make view query wait for drop and create operations
- changed security checks for the import logic to avoid sprious failures
- optimizatons in disk cache implementation 
- pre-check cluster existence to avoid storage to go in read only mode in case of duplicate cluster
- add check to avoid failure when engines are unloaded, issue #9629
- removed not used configurations
- moved cleanup of old structures out of the view refresh window
- replaced global executor with context executor
- use correct index in immutable view metadata
- add configuration for define the max number of threas for the context executor

## Server
- make sure to print the right protocol for studio address when ssl is enabled

## Client
- minor fix on view metadata serialization and deserializatin over network

## Distributed

- Removed not used single cluster management in distributed sync

## Spatial

- Fix spacial function filtering when used trough the new query engine


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.16 - (February, 8 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3216---8-February-2023

# Core
- removed the need to buffer changes before adding the to the tx
- make sure to stop scheduling of view refresh before closing the OrientDB instance
- improved refreshing and cleaning of views
- minor fix to handle misstyped records in delta serialization
- minor correction on metadata snapshot logic on release of index manager lock
- make sure to use transaction aware stream also with legacy index implementations, issue #9914
- reduced the number of times the storage goes in read only mode, and allow to delete not empty datastructures
- make sure that on index load the schema snapshot are available, issue #9915
- changes in index manager and view implementation to avoid cross locking during updates
- avoid to re-index new cluster when swapping the cluster in views.
- make sure to initialize the timeout checker before the system db

# Remote
- made remote index changes go through the transaction instead of the query

# Distributed
- make sure to have the correct transaction in the context for distributed phases execution
- managed correctly the check of all value of a unique index during first phase checks

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.15 - (Jennuary, 17 2023)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3215---17-January-2023

# Core
- give more clear error when view metadata are not correct on view creation
- improved validation of embedded types to avoid use of vertices and edges in embedded
- handle additional case for shape type conversion in query engine
- removed not needed synchronization in views structures
- reduced logging of the security module
- minor fix for no-tx changes on lucene indexes
- removed duplicate logic in index implementation
- reduced the thread local lookups and database isClosed checks
- removed some locale translate done only on specific use cases
- avoid to update the index manager when there are no changes
- replaced storage error state lock with atomic reference
- removed server and client dependency from lucene module

# Distributed
- minor fix on view creation and refresh in case of distributed environment

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.14 - (December, 23 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3214---23-December-2022

# Core
- Optimization on graph delete operations (issue #9821)
- Fix on remote deserialization of specific exception
- Fix on index logic for multi-page split
- Fix limit of index key size, now it fail with a user message when the key is over the maximum size (10Kb)
- Optimization in index write
- Optimization of security checks in writes
- Fix wrongly oversize WAL records
- Fix views locking logic to update the view atomically
- Fix failing schedule of view if previous view fail to refresh
- Add support of indexing of embedded types in views
- Fixed script poll release issue  

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.13 - (December, 1 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3213---1-December-2022

# Core
- Make sure to use high level transactions in all index change cases
- Made index rebuild batch changes in transaction
- Fix view unlocking in case of refresh error
- Optimized update of vertices that use ridbag trees
- Fix regression on OResult hash code, issue #9900
- Ignore index corrupted errors on drop
- Batched view refreshing in transaction
- Optimized of usage of read/write lock in storage
- Fix check of index type also on chained indexes 
- Reduced usage of modifiable schema to reduce contention on read/write lock
- Fix waiting for last task in ViewManager close
- Fix running of ddl while incremental backup is running do not block anymore other write operations.
- Fix invalid cluster id do not make storage readonly

# Distributed
- Fix in handling of node missing on refresh

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.12 - (November, 10 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3212---10-November-2022

# Core 
- Add timeout check in next query page fetching
- Updated dependencies
- Optimized Security Policies checks
- Optimized query engine property fetching and filtering
- Removed not used anymore dependencies
- Fix in truncate clusters logic
- Improved string caching logic
- Made the direct memory pointer soft reference to retain it and reduce the allocation overhead
- Add a correct error message when opening a not existing database in a in memory context
- Fix regression in sql function execution after refactor, issue #9888
- Optimization in storage record reading
- Fix OClass.setCustom() in ditributed setup

# Console
- Fix regression database creation, issue #9889

# Enterprise
- Limited the maximum number of metrics kept in memory
- Made query statements metrics ognostic of values

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.11 - (October, 19 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3211---19-October-2022

# Core 
 - Use correct configuration to run javascript functions on truffle script engine of graal
 - Minimize duplicate logic in index searching for query engine
 - Add caching of graal Context with relative database functions
 - Reduced allocations in query engine
 - Add possibility to unload cached information for specific script executor
 - Optimized the cluster computation in query engine
 - Disabled the sharding check logic for distributed
 - Removed dependencies not used anymore
 - Correct query interrupt based on command timeout configuration
 - Minor updates of dependencies 

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.10 - (September, 15 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#3210---15-September-2022

# Core
 - Make put of index everytime transactional
 - Converted all left put operations to use transaction directly
 - Fix logging of log messages with exceptions
 - Refactor for simplify index creation logic
 - Optimization in index write logic
 - Optimization in ridbag write logic
 - Optimization in page write logic
 - Optimization in script pool 
 - Disabled write operations without atomic operation
 - Fixes in Json parsing
 - Re-enabled computation of record sizes for cluster issue #9870
 - Replaced custom lock implementation with jdk implementation
 - Avoid to read null values from json for ridbags

# Client
 - Automatically start a transaction in the client side if a script started it server side

# Lucene
 - Correct lucene remove after transactional index operations refactor
 - Make sure rebuild of lucene works after refactor

# Distributed
 - Fix copyStream to not terminate on 0 byte read
 - Mark HA STATUS idempotent so it can be used from SQL API.
 - Include individual DB status across cluster in HA STATUS result
 - Add exception details to some logging that lost stack traces.

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.9 - (August, 11 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#329---11-August-2022

# Core
- Make sure to drop the database also when drop listeners fail
- Improve thread pool executors to scale up and down properly
- Make sure to release lock on close of failed storage
- Removed background thread to mark storage broken not needed anymore
- Add missing file extension from list of database files extensions to allow proper cleanup on delete
- Remove no needed refresh of immutable metadata during index metadata load
- Avoid that wrong validation value make a database read only
- Corrected regression on btree v3 value replace
- Refactor to  simplify  index v3 logic
- Prevent Live Query thread hot looping on idle queue.

# Distributed
- Improved distributed hosts change notification after client optimization

# Remote
- Release session lock in any case of error

# Etl
- Make sure to close context on process shutdown

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.8 - (June, 26 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#328---26-June-2022

# Core
- avoid to make the storage read only in case of error in record serialization
- correct iterable value set during update operations issue #9781
- avoid to put storage in read only in case of errors during read operations
- fixed multivalue composite index queries to not return duplicates
- correct indexes rebalancing causing error on delete operations

# Console
- local creation of a database in plocal with console old command will create a admin user

# Distributed 
- unblock distributed request handling in case of install error, issue #9815
- Cap string length in binary channels

# Lucene
- Support parameterised metadata in Lucene queries
- make sure that lucene parsing exception do not set the storage in read only mode, issue #9498
- Fix the locking in the Lucene indexer

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.7 - (June, 8 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#327---8-June-2022

# Core
- fixed delete of lucene indexes 
- make sure to do a clean metadata re-init after incremental backup database restore
- handle thread interruption while data read and write with correct exception
- Speed up of record updates.
- remove edges with in or out null during bonsai repair,issue  #9806
- minor correction in composite index creation query

# Distributed
- cloned distributed lock keys that may contain a record id for avoid mutation
- properly handle database instance used by lucene indexes while distributed sync
- Install ShutdownLogManager in distributed mode


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.6 - (April, 28 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#326---28-April-2022

# Changes

## Core
- LSN of latest applied record returned during restore
- Binary compatibility issue was fixed
- Update jackson dependency to the latest release
- Disabled memory pre-allocation by default
- Ported fix for shortest path, issue #9774
- Minor update of dependency version
- Storage state lock was replaced by standard JDK lock

## Distributed

- Minor fix for distributed on deploy database backup in case of source folder and dest folder in different volumes
- Fixes on network layer between nodes

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.5 - (February, 14 2022)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#325---14-february-2022

# Changes

## Core
- Restore flag is triggered once physical restore is started.
- Tracking of consistency of atomic operation on restore was added.
- If Unsafe is present it is used for memory allocation/de-allocation.
- Fix toJson() with spaces in map key names.
- Prevention of recursive flow of exception is case of internal error.
- DWL files do not trigger errors during the database backup.
- Fix ORDER BY with LET

## Distributed
- Minor fix in distributed stat collecting logic
- Check to avoid distributed backup path to be in the same location of databases
- Minor refactor to avoid to do version promises for not changed records


-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.4 - (December, 28 2021)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#324---28-december-2021

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.3 - (November, 16 2021)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#323---16-november-2021

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.2 - (September, 21 2021)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#322---21-september-2021

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.1 - (September, 8 2021)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#321---8-september-2021

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.2.0 - (April, 29 2021)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.2-Release-Notes#320---29-april-2021





-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.1.0 Beta 1 - (October, 25 2019)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.1-Release-Notes#310beta1---25-october-2019

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.1.0 M3 - (July, 2 2019)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.1-Release-Notes#310M3---2-july-2019

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.1.0 M2 - (October, 5 2018)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.1-Release-Notes#310M2---5-october-2018

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.1.0 M1 - (September, 24 2018)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.1-Release-Notes#310M1---24-september-2018



-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.0.3 - (July, 2 2018)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.0-Release-Notes#303---2-july-2018
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A3.0.3+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.0.2 - (June, 5 2018)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.0-Release-Notes#302---5-june-2018
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A3.0.2+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.0.1 - (May, 18 2018)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.0-Release-Notes#301---18-may-2018
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A3.0.1+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.0.0 - (Apr, 9 2018)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.0-Release-Notes#300---9-april-2018
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A3.0.0+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.0.0RC2 - (Feb, 27 2018)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.0-Release-Notes#30-rc2
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A3.0.0-RC2+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.32 - (February, 5 2018)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2232
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.32+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.0.0RC1 - (Dec, 18 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.0-Release-Notes#30-rc1
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A3.0.0-RC1+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.31 - (December, 12 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2231
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.31+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.30 - (November, 14 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2230
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.30+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.29 - (October, 5 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2229
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.29+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.28 - (September, 26 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2228
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.28+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.27 - (September, 13 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2227
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.27+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.26 - (August, 16 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2226
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.26+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.25 - (August, 2 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2225
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.25+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.0.0-M2 - (Jul, 27 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.0-Release-Notes#30-m2
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A3.0.0-m2+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.24 - (July, 20 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2224
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.24+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.23 - (July, 7 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2223
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.23+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.22 - (June, 19 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2222
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.22+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.21 - (May, 31 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2221
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.21+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.20 - (May, 11 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2220
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.20+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.19 - (Apr, 26 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2219
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.19+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 3.0.0-M1 - (Apr, 14 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-3.0-Release-Notes#30-m1
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A3.0.0-m1+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.18 - (Apr, 6 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2218
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.18+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.17 - (Feb, 16 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2217
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.17+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.16 - (Feb, 02 2017)
- Release Notes: https://github.com/orientechnologies/orientdb/wiki/OrientDB-2.2-Release-Notes#2216
- Issues: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.16+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.15 - (Jan, 18 2017)
- Core (28): https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.15+is%3Acloseda

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.14 - (Dec, 19 2016)
- Core (32): https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+is%3Aclosed+milestone%3A2.2.14

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.13 - (Nov, 15 2016)
- Core (34): https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+is%3Aclosed+milestone%3A2.2.13

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.12 - (Oct, 20 2016)
- Core (18): https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+is%3Aclosed+milestone%3A2.2.12

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.11 - (Oct, 3 2016)
- Core (38): https://github.com/orientechnologies/orientdb/issues?q=is%3Aclosed+is%3Aissue+milestone%3A2.2.11

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.10 - (Sep, 15 2016)
- Core (12): https://github.com/orientechnologies/orientdb/issues?q=is%3Aclosed+is%3Aissue+milestone%3A2.2.10

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.9 - (Sep, 8 2016)
- Core (15): https://github.com/orientechnologies/orientdb/issues?q=is%3Aclosed+is%3Aissue+milestone%3A2.2.9

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.8 - (Aug, 24 2016)
- Core (12): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.2.8+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.7 - (Aug, 11 2016)
- Core (16): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.2.7+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.6 - (Jul, 27 2016)
- Core (5): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.2.6+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.5 - (Jul, 2- 2016)
- Core (12): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.2.5+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.4 - (Jul, 7 2016)
- Core (26): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.2.4+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.3 - (Jun, 20 2016)
- Core (7): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A%222.2.2.3%22+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.2 - (Jun, 13 2016)
- Core (88): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A%222.2.2.2%22+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.0 - (May, 18 2016)
- Core (35): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A%222.2.0+GA%22+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.0-rc1 - (April, 27 2016)
- Core (17): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.2.0-rc1

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.0-beta2 - (March, 30 2016)
- Core (25): https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.2.0-beta2

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.2.0-beta - (February, 18 2016)

CHANGELOG:
- Core
 - New Dirty Manager
 - New Incremental Backup (Enterprise Edition only)
 - Automatic minimum clusters
 - AES and DES enchryption
 - Support SALT in passwords
- Distributed
 - Fast synchronization of nodes by copying only the delta of changes
-  Load balancing on the client side
- SQL
 - New Pattern matching
 - New Command Cache
 - New Automatic parallel queries
 - New Prefetching of disk pages
 - Live Query are finally stable
 - New 'Update Edge' command
 - New Sequences
 - New 'Move cluster' command
 - New Commands to manage users
- Studio, new P2P architecture, new Enterprise modules (it replaces the Enterprise Workbench)
- Lucene, new module for indexing of shapes, not only points
- OrientJS, Native unmarshaling of requests by using C++ code
- 103 total issues resolved

CHANGELOG: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.2.0-beta+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.1.0 (GA) - (August, 5 2015)
- New Studio Server Management console
- 31 issues resolved from OrientDB 2.1-rc6.

CHANGELOG:
- Core (30)..: https://github.com/orientechnologies/orientdb/issues?q=milestone%3A%222.1+GA%22+is%3Aclosed
- Studio (1).: https://github.com/orientechnologies/orientdb-studio/issues?q=is%3Aissue+milestone%3A%222.1+GA%22+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.1-rc6 - (July, 28th 2015)
- 153 issues resolved from OrientDB 2.1-rc5.

CHANGELOG:
- Core (126).: https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.1-rc6+is%3Aclosed
- ETL (6)....: https://github.com/orientechnologies/orientdb-etl/issues?q=milestone%3A2.1-rc6+is%3Aclosed
- Lucene (8).: https://github.com/orientechnologies/orientdb-lucene/issues?q=milestone%3A2.1-rc6+is%3Aclosed
- JDBC (1)...: https://github.com/orientechnologies/orientdb-jdbc/issues?q=milestone%3A2.1-rc6+is%3Aclosed
- Studio (12): https://github.com/orientechnologies/orientdb-studio/issues?q=milestone%3A2.1-rc6+is%3Aclosed

-----------------------------------------------------------------------------------------------------------------------------------
VERSION 2.1-rc5 - (July, 3rd 2015)
- Bug fixing: 43 issues from 2.1-rc4.

https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.1-rc5+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.1-rc4 - (June, 17th 2015)
- Bug fixing: 45 issues from 2.1-rc3.

https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.1-rc4+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.1-rc3 - (May, 22nd 2015)
- Bug fixing: 38 issues from 2.1-rc2.

https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.1-rc3+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0.9 - (May, 14th 2015)
- Bug fixing: 21 issues from 2.0.8.

https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0.9+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0.8 - (April, 22nd 2015)
- Bug fixing: 17 issues from 2.0.7.

https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0.8+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.1-rc2 - (May, 5th 2015)
- Bug fixing: 32 issues from 2.1-rc1.

https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A2.1-rc2+is%3Aclosed
---------------------------------------------------------------------------------------------------
VERSION 2.1-rc1 - (April, 16th 2015)

https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.1-rc1+is%3Aclosed

- Schema: Support for Multiple inheritance where classes can extend from multiple super classes
          Support for default values (functions are allowed)
- Core: Improved WAL management (Journal) to enforce Consistency with transactions 
        Fetch-plan supports wildcard for names
- SQL: New SQL parser by default on with new databases and off with those created with old versions
       Prepared Statements and substitution of parameters and target
       New Live Query to write Reactive applications
       New optimization about using of indexes in sub-classes if present
       New concat() function
- Distributed: Support for slave (read-only) nodes
               Included Hazelcast-all.jar including also Cloud support
- ETL: Skip duplicated vertices
- Bug fixing: 104 issues in total

---------------------------------------------------------------------------------------------------
VERSION 2.0.7 - (April, 14th 2015)
- Bug fixing: 10 issues from 2.0.6.
https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0.7+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0.6 - (March, 31st 2015)
- Bug fixing: 19 issues from 2.0.5.

https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0.6+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0.5 - (March, 12th 2015)
- Bug fixing: 11 issues from 2.0.4.

https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0.5+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0.4 - (March, 3rd 2015)
- Bug fixing: 7 issues from 2.0.3.

https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0.4+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0.3 - (February, 20th 2015)
- Bug fixing: 10 issues from 2.0.2.

https://github.com/orientechnologies/orientdb/issues?q=milestone%3A%222.0.3+%28hotfix%29%22+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0.2 - (February, 9th 2015)
- Bug fixing: 11 issues from 2.0.1.

https://github.com/orientechnologies/orientdb/issues?q=milestone%3A%222.0.2+%28hotfix%29%22+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0.1 - (January, 28th 2015)
- Bug fixing: 10 issues from 2.0.

Full list: https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0.1+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0 - (January, 20th 2015)
- Core: logged database name on server and embedded messages
- SQL: added UNSAFE to CREATE PROPERTY command to avoid slow checks
       auto conversion from map when working on EMBEDDED types
- Bug fixing: 54 total issues from 2.0-RC2.

Full list: https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A%222.0+Final%22+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0-RC2 - (January, 12th 2015)
- Bug fixing: 86 total issues from 2.0-RC1.

Full list: https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0-rc2+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 2.0-RC1 - (December, 17th 2014)
- Core: Avoid rebuild of indexes if working in Transactional mode
- Javascript: Invoking of JS functions now is 10x faster
- Network: Support for state less requests using Token
- Graph API: Disabled light weight edges by default
- Bug fixing: 87 total issues from 2.0-M3.

Full list: https://github.com/orientechnologies/orientdb/issues?q=milestone%3A%222.0-RC1+(Release+Candidate)%22+is%3Aclosed
---------------------------------------------------------------------------------------------------
VERSION 2.0-M3 - (November, 18th 2014)
- Core: Cluster selection strategy now can decide on the input document content
        Better automatic alloc of Heap and Disk-Cache
        Clusters can be detached (offline) and re-attached (online)
        FetchPlan: support for wildcards
        Improved pools
        Using SIGTRAP (kill -5) to dump OrientDB information
        Fixed connection pool problem on high usage
        Cache is always ON and can’t be disabled anymore. This avoids many common issues with users
- Schema: used immutable instances to reduce locking contention
- Graph API: New OGraphBatchInsertBasic and OGraphBatchInsert API for massive insertion on graphs:
             13x faster than Blueprints
- Document API: Removed a couple of internal layers to speedup and simplify implementation
- Studio: Simplified database creation (graph - no lightweight edges by default)
- Console: Displayed also @class
- Bug fixing: 115 total issues from 2.0-M2.

Full list: https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0-M3+is%3Aclosed
---------------------------------------------------------------------------------------------------
VERSION 2.0-M2 - (September, 29th 2014)

- Studio: Improved Graph Editor, fixed many bugs to improve UX
- Server: On first run ask for root password. Blank means auto-generate (like before)
- Core: Added ODocument.fromMap() and ODocument.toMap()
        Removed memory OWatchDog thread
        Pool, new methods to get internal information
        Merged in core commons and native-os modules
        Auto configure of Off-Heap memory used by DiskCache
- Graph API: new requireTransaction setting to check TX is begun on graph changes
- Distributed: Supported asynchronous replication via API and Configuration
               On first run ask for node name. Blank means auto-generate (like before)
               Unified script and config with stand-alone server

- Bug fixing: 40 from 2.0-M1.

Full list: https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0-M2+is%3Aclosed
---------------------------------------------------------------------------------------------------
VERSION 2.0-M1 - (September, 17th 2014)

- Studio: New Layout, new Graph Editor, new Security panel (Users and Roles management)
- Security: Added configurable SSL keystore and truststore
- Memory: In-Memory database uses off-heap cache
- Graph API: New OrientGraphAsynch, first experimental version of asynchronous graph
             New SQL MOVE VERTEX command to refactor portion of graphs and to move vertices between
               distributed nodes
             Improved OrientGraphFactory performance reducing recycling time. Added central config
               of generated graphs in Factory
             Creation of edges doesn’t update both vertices anymore. Much faster now
- Console: Improved layout
- Distributed: 3x of performance improvement
- Core: New Schema Driver Serialization: avoid writing field names for records with Schema
         
        Added strategies to manage conflict: by content and auto-merge. Furthermore can be injected
          custom strategy via Java API
        New RWLocks to speedup internal parallelism        
        Disabled SNAPPY compression by default
        Improved schema concurrency
        Removed 2nd level cache
- SQL: New UUID() function to generate Unique IDs
       New statistic functions: mode(), variance(), stddev(), median(), percentile()
       New SQL MOVE VERTEX command to refactor portion of graphs and to move vertices between
       Rewritten implementation of shortestPath() function
       Improvement for “order by @rid desc” to browse results in opposite direction without
          use an index or RAM.
- Configuration: Global settings are copied in database at creation time and can be update
- Bug fixing: 20 from 1.7.9, hundreds from 1.7.

Full list: https://github.com/orientechnologies/orientdb/issues?q=milestone%3A2.0-M1+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 1.7.8 - (August, 13th 2014)

- DevOps: new bin/backup.sh with -lvm option to execute a non-blocking backup on Linux with LVM
          installed
- Hot fixes:
   https://github.com/orientechnologies/orientdb/issues?q=is%3Aissue+milestone%3A1.7.8+is%3Aclosed

---------------------------------------------------------------------------------------------------
VERSION 1.7.7 - (July, 23th 2014)

Hot fixes: https://github.com/orientechnologies/orientdb/issues?milestone=24&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7.6 - (July, 16th 2014)

Hot fixes: https://github.com/orientechnologies/orientdb/issues?milestone=23&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7.5 - (July, 10th 2014)

Hot fixes: https://github.com/orientechnologies/orientdb/issues?milestone=22&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7.4 - (June, 23rd 2014)

Hot fixes: https://github.com/orientechnologies/orientdb/issues?milestone=21&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7.3 - (June, 12th 2014)

Hot fixes: https://github.com/orientechnologies/orientdb/issues?milestone=20&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7.2 - (June, 7th 2014)

Hot fixes: https://github.com/orientechnologies/orientdb/issues?milestone=19&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7.1 - (June, 4th 2014)
---------------------------------------------------------------------------------------------------
Hot fixes: https://github.com/orientechnologies/orientdb/issues?milestone=18&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7 - (May, 27th 2014)

- Core: new “minimumclusters” to auto-create X clusters per class
        new cluster strategy to pick the cluster. Available round-robin, default and balanced
        added record locking via API
        removed rw/locks on schema and index manager
        cached most used users and roles in RAM (configurable)
- Server: New support for SSL connections on binary and HTTP protocols 
- Console: New “script” command to execute multiple SQL statements + transaction control
           New “next” command to move the cursor on the next record in the result set
           New “pref” command to move the cursor on the previous record in the result set
           New “move <predicate>” command to move from current record by executing a predicate
           New “eval <predicate>” command to evaluate a predicate against current record
           Ability to ignore errors by setting “set ignore = true”
- Distributed: New support for sharding
               Simplified (JSON) configuration
- Graph: New functions to return the traversed items: traversedVertex(), traversedEdge() and
          traversedElement()
         addEdge() can takes ORID to use implicitly last record version
- SQL: New PARALLEL keyword to run the query on multiple threads
       New “INSERT INTO … SELECT” to copy records
       New “INSERT INTO … RETURN <expression>” to return expressions on INSERT
       New “UPDATE … RETURN <expression>” to return expressions on UPDATE
       distance() accepts measure unit (default = km)
- HTTP: added support for context variables in SCRIPT command
- Indexes: Added Full-Text Lucene indexes (as plugin)
           Added GEO Spatial Lucene indexes (as plugin)
           Added WAL (Journal) support for Hash-Index so can be used in Transactions
           Added NULL support for composite and non-composite indexes
           Full-Text can be configured through METADATA keyword
           Full-Text now indexes also sub-words
           Improved SQL optimizer by avoiding calling evaluate() when not needed
           LINKSET types can be indexed now
           RID can be used on composite indexes
- Studio: Bookmarks for queries
          Ability to interrupt running commands
- Bug fixing: 135 issues in total

Full list: https://github.com/orientechnologies/orientdb/issues?labels=&milestone=16&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7-rc2 - (March, 25th 2014)

- Core: supported retro-compatibility for databases created with OrientDB v1.5 or further (#1899)
        improved performance on ORDER BY against indexes (#1843)
        improved performance on RENAME CLASS (#1818)
- Graph: added support for vertex-centric traversal by using SQL (#2079)
-        added support for vertex-centric traversal by using SQL (#2079)
- SQL: new UPSERT keyword to execute an INSERT or UPDATE based on a condition (#2032)
       UPDATE now can ADD also to sub-document fields (#2031)
- Indexes: added support for external engines (#1774)
- Studio: new Query Timeline to the History, new Index Panel, Fixed many bugs
- Bug fixing: 62 bugs in total

Full list: https://github.com/orientechnologies/orientdb/issues?labels=&milestone=13&page=3&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.7-rc1 - (February, 6th 2014)

- Engine: new LINKBag to manage LINKS by using SBTree indexes. This drastically improved performance
- SQL: new LOCK keyword to specify locking strategy
       new RETURNING keyword to let to UPDATE and DELETE commands to return modified records
       new include() and exclude() to respectively include or exclude fields of documents
       operator [] now can be used in chain, also with functions
       projections can be reused as variables
       support for LET also in UPDATE and DELETE commands
- Graph API: support for ordered edge list
             new detach() and attach() method to work with Graph Element offline
             new OrientGraphFactory to manage pooled instances
- HTTP: new support for ETag, If-Match and If-None-Match headers
        new PATCH method against /document command and /documentbyclass for partial updates
- Distributed: database deploy now is chunked to avoid RAM saturation
- Backup and Restore: improved speed from 5x to 50x
- Studio: new CSV download of Query result

Full list: https://github.com/orientechnologies/orientdb/issues?milestone=15&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.6.4 - (January, 16th 2014)

- Integrated Blueprints API in “graphdb” module
- Bug fixing

---------------------------------------------------------------------------------------------------
VERSION 1.6.3 - (December, 27th 2013)

- Bug fixing

---------------------------------------------------------------------------------------------------
VERSION 1.6.3 - (December, 27th 2013)

- Bug fixing

---------------------------------------------------------------------------------------------------
VERSION 1.6.2 - (December, 9th 2013)

- Support for COLLATE to case insensitive compare fields
- Bug fixing

Full list: https://github.com/orientechnologies/orientdb/issues?milestone=11&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.6.1 - (November, 20th 2013)

- Bug fixing

Full list: https://github.com/orientechnologies/orientdb/issues?milestone=10&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.6 - (October, 31nd 2013)

- SBTree: new index engine with the support for transactions and range queries
- Distributed: new Architecture based on Hazelcast, new Distributed Transaction support across
  nodes, new Database Sharding feature
- Studio: total rewriting in a new tool hosted on separate project
- HTTP: execute commands in batch mode, partial document updates, JSON as return of create and
        update documents, management of multi databases in the same connection
- Scripts: new Orient variable to get database instances, new switchUser() API to change current
           user
- Plugins: new hot deployment plugin as folders, zip and jar files
- SQL: new target "metadata" to retrieve schema and indexes
- Console: new silent mode
- Many features and performance improvements on plocal and hash indexes
- Bug fixing

Full list: https://github.com/orientechnologies/orientdb/issues?milestone=8&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.5.1 - (September, 3rd 2013)

- New PLOCAL (Paginated Local) storage engine. In comparison with LOCAL it's more durable (no usage
  of MMAP) and supports better concurrency on parallel transactions
- New Hash Index type with better performance on lookups. It does not support ranges
- New "transactional" SQL command to execute commands inside a transaction. This is useful for
  "create edge" SQL command to avoid the graph get corrupted
- Import now migrates RIDs allowing to import databases in a different one from the original
- "Breadth first" strategy added on traversing (Java and SQL APIs)
- Server can limit maximum live connections (to prevent DOS)
- Fetch plan support in SQL statements and in binary protocol for synchronous commands too
- Distributed configuration
- Bug fixing

Full list: https://github.com/orientechnologies/orientdb/issues?milestone=5&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.4.2 - (July, 29th 2013)
---------------------------------------------------------------------------------------------------
- Bug fixing

Full list: https://github.com/orientechnologies/orientdb/issues?milestone=7&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.4.1 - (June, 18th 2013)
---------------------------------------------------------------------------------------------------
- Bug fixing

Full list: https://github.com/nuvolabase/orientdb/issues?milestone=6&page=1&state=closed

---------------------------------------------------------------------------------------------------
VERSION 1.4.0 - (June, 7th 2013)
---------------------------------------------------------------------------------------------------
- Graph: total rewrite of Blueprints API that now are the default Java interface, support for
         light-weight edges (no document), labeled relationships using separate classes and vertex
         fields
- Storage: new Paged-Local compressed "plocal" engine  (not yet transactional)
- SQL: INSERT and UPDATE supports JSON syntax, improved usage of indexes upon ORDER BY, supported
       timeout in query and global, new create function command, flatten() now is expand(), new
       OSQLMethod classes to handle methods even in chain, new encode() and decode() functions,
       support for new dictionary:<key> as target in SELECT and TRAVERSE
- new SCHEDULER component using CRON syntax
- new OTriggered class to use JS as hook
- MMap: auto flush of pages on regular basis
- Fetch-plan: support for skip field using "-2"
- Index: auto rebuild in background, usage of different data-segment
- Export: supported partial export like schema, few clusters, etc.
- Console: improved formatting of resultsets
- HTTP: new /batch command supporting transaction too, faster connection through /connect command,
        /document returns a JSON
- Studio: UML display of class

Full list: https://github.com/nuvolabase/orientdb/issues?milestone=2&state=closed

-------------------------------------------------------------------------------
VERSION 1.3.0 - (December, 19th 2012)
-------------------------------------------------------------------------------
- SQL: new eval() function to execute expressions
- SQL: new if(), ifnull() and coalesce() functions
- SQL: supported server-side configuration for functions
- SQL: new DELETE VERTEX and DELETE EDGE commands
- SQL: execution of database functions from SQL commands
- SQL: new create cluster command
- Graph: bundled 2 algorithms: Dijkstra and ShortestPath between vertices
- Performance: improved opening time when a connections is reused from pool
- Performance: better management of indexes in ORDER BY
- Schema: new API to handle custom fields
- HTTP/REST: new support for fetch-plan and limit in "command"
- Moved from Google Code to GitHub: https://github.com/nuvolabase/orientdb

Full list: https://github.com/nuvolabase/orientdb/issues?milestone=1&page=1&state=closed

-------------------------------------------------------------------------------
VERSION 1.2.0 - (October, 10th 2012)
-------------------------------------------------------------------------------
- Functions: these are like Stored Procedures for RDBMS but in Javascript
- Record Level Security, just let the class to protect overriding the
  ORestricted abstract class
- Profiler: generation of snapshots
- JMX now is a plugin (not more installed by default)
- Automatic rebuild of schema index on restart after a crash/hard shutdown
- SQL: new EXPLAIN command to profile any commands, new SQL LET keyword to set
       context variables, support for Sub-Queries in CREATE EDGE
- Object Database JPA interface: support for configurable naming policy
- Supported abstract classes (without record cluster)
- Partial unmarshalling of fields to speed up queries
- Automatic backup can start at concrete time
- Console: prompt password if not provided
- Renamed traverse's WHERE in WHILE
- 65 bugs fixed!

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.2.0%2Cv1.2

-------------------------------------------------------------------------------
VERSION 1.1.0 - (July, 24th 2012)
-------------------------------------------------------------------------------
- New distributed server architecture with balance of workload, full
  replication and management of failures
- New MMAP manager optimized for 64bit OS
- Index: new support for binary keys and collections in composite keys
- Support for in-memory database replication
- Object Database added support for attach/detach, ENUM and binary
  data (ORecordBytes)
- SQL: new DROP CLUSTER command, INSERT now supports clusters,
  new CREATE VERTEX and CREATE EDGE commands
- Support for Gephi visual tool
- 50 bugs fixed

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.1.0

-------------------------------------------------------------------------------
VERSION 1.0.1 - (May, 22nd 2012)
-------------------------------------------------------------------------------
- support for TinkerPop 2.0 technology stack
- new OBinary type to index binary field
- Bugs fixed

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0.1

-------------------------------------------------------------------------------
VERSION 1.0 - (May, 14th 2012)
-------------------------------------------------------------------------------
- new Multi-Master Replication architecture
- new Object Database interface that use run-time enhancement. Now handles lazy
  loading, it's lighter and faster than before
- new OTraverse class to traverse graphs via Java API using a stack-free
  approach
- Data segments: added support for multiple ones and create/drop commands
- new ODocument.undo() to revert local changes
- new Server Side Scripting support
- Query: new context variables
- Console: new check database command
- Studio: improved Graph management
- Improved OSGi support
- Fixed more than 40 bugs

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0

-------------------------------------------------------------------------------
VERSION 1.0rc9 - (March, 26th 2012)
-------------------------------------------------------------------------------
- Studio new look&feel and improved Query panel
- SQL: new sub query, new SKIP keyword for pagination,
       INSERT accepts SET syntax like SQL UPDATE
- Update Tinkerpop stack: Gremlin 1.5, Blueprints 1.2 and Pipes 1.0
- Schema: new support for metadata on property
- Many bug fixed, 35 issues in total

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0rc9

-------------------------------------------------------------------------------
VERSION 1.0rc8 - (February, 2nd 2012)
-------------------------------------------------------------------------------
- New TRAVERSE command to traverse records by relationships
- New fetch-plan to support more complex use cases
- Asynchronous API to speedup insert, update and delete via remote network
- New DECIMAL type to handle currency without pains of float and double types
- Strict schema mode to work like a Relational DBMS
- Resolved the "big-node" problem when a record has many links to other
  records by using a MVRB-Tree to handle relationships
- SQL: new NOT and INSTANCEOF operators
- Index works also against MAP types
- Supported JPA @Embedded annotation
- Many bug fixed, 54 issues in total

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0rc8

-------------------------------------------------------------------------------
VERSION 1.0rc7 - (December, 5th 2011)
-------------------------------------------------------------------------------
- Transactions: Improved speed, up to 500x! (issue 538)
- New Multi-Master replication (issue 589). Will be final in the next v1.0
- SQL insert supports MAP syntax (issue 582), new date() function
- HTTP interface: JSONP support (issue 587), new create database (issue 566),
  new import/export database (issue 567, 568)
- many bug fixed, 34 issues in total

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0rc7
-------------------------------------------------------------------------------
VERSION 1.0rc6 - (October, 11th 2011)
-------------------------------------------------------------------------------
- SQL engine: improved link navigation (issue 230)
- Console: new "list databases" command (issue 389)
- Index: supported composite indexes (issue 405), indexing of collections
        (issue 554)
- JPA: supported @Embedded (issue 436) and @Transient annotations
- Object Database: Disable/Enable lazy loading (issue 563)
- Server: new Automatic backup task (issue 556), now installable as
          Windows Service (issue 61)
- Client: Load balancing in clustered configuration (issue 557)

-------------------------------------------------------------------------------
VERSION 1.0rc5 - (August, 22nd 2011)
-------------------------------------------------------------------------------
- SQL engine: new [] operator to extract items from lists, sets, maps and
  arrays
- SQL engine: ORDER BY works with projection alias
- SQL engine: Cross trees and graphs in projections
- SQL engine: IN operator uses Index when available
- Fixed all known bugs on transaction recovery
- Rewritten the memory management of MVRB-Tree: now it's faster and uses much
  less RAM
- Java 5 cmopatibility of common and core subprojects
- 16 issues fixed in total

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0rc5

-------------------------------------------------------------------------------
VERSION 1.0rc4 - (August, 1st 2011)
-------------------------------------------------------------------------------
- SQL engine: improved mixing functions and operators all together in complex
  combinations
- SQL engine: supported array, collection and maps as query parameters
- New SQL TRUNCATE RECORD command
- JARs are OSGi compliant
- GraphDB: Renamed Vertex "outEdges" and "inEdges" in respectively "out" and 
  "in"
- Fixed problems with drop clusters
- 21 issues fixed in total

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0rc4

-------------------------------------------------------------------------------
VERSION 1.0rc3 - (July, 14th 2011)
-------------------------------------------------------------------------------
- Improved Index manager to use index also with multiple query condition
  (many thanks to the Exigen team!) 
- Fixed problems with schema refreshing
- Fixed a lot of bugs with distributed clustered configuration (thanks to the
  NuvolaBase team!) 
- New SQL ALTER CUSTER command
- New SQL operator EXISTS
- GraphDB: new SQL GREMLIN() operator to execute Gremlin scripts against the
  SQL query resultset
- GraphDB: integrated Gremlin as command script implementation
- Improved disk space allocation
- Improved performance in general
- 34 issues fixed in total!

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0rc3

-------------------------------------------------------------------------------
VERSION 1.0rc2 - (June, 17th 2011)
-------------------------------------------------------------------------------
- Fixed multi-threads problems
- Speeded up index searching
- Refactored schema, index and security managers to work in multi-threads
- When use remote as protocol, triggers now work at server-side level
- New SQL BETWEEN operator, useful specially against indexes to execute
  ranged queries
- New SQL ALTER CLASS and ALTER PROPERTy to refactor the db schema
- New Console DROP DATABASE command
- New Console INDEXES command that displays the configured indexes
- New DATE type to handle dates only with YYYY/MM/SS
- New SQL distinct() function
- New SQL union(), intersect() and difference() functions to work with
  collections
- MVCC (Multi-version Concurrency Control) system is enabled also outside
  transactions by default, but can be turned off
- Supported +, -, *, / and % math operations in SQL Query
- Enforced security checks
- GraphDB support multiple edges between two vertexes
- Core is Java5 compatible, the server needs Java6
- 80 issues fixed in total!

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label%3Av1.0rc2

-------------------------------------------------------------------------------
VERSION 1.0rc1 - (May, 3rd 2011)
-------------------------------------------------------------------------------
- New defrag algorithm to reduce holes and therefore disk space
- New super fast lazy collections that optimizes marshalling/unmarshalling
- HTTP protocol handles multipart requestes
- New HTTP Download and Upload commands
- Fixed problems with cluster configuration when multiple dbs was opened
- Added 8 new configuration parameters
- new OLockManager class to lock at record level
- Many bugs fixed

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label:v1.0rc1

-------------------------------------------------------------------------------
VERSION 0.9.25 - (March, 2nd 2011)
-------------------------------------------------------------------------------
- Brand new memory model with level-1 and level-2 caches (Issue #242)
- SQL prepared statement (Issue #49)
- SQL Projections with the support of links (Issue #15)
- Graphical editor for documents in OrientDB Studio app (Issue #217)
- Graph representation in OrientDB Studio app
- Support for JPA annotation by the Object Database interface (Issue #102)
- Smart Console under bash: history, auto completition, etc. (Issue #228)
- Operations to work with GEO-spatial points (Issue #182)
- @rid support in SQL UPDATE statement (Issue #72)
- Range queries against Indexes (Issue #231)
- 100% support of TinkerPop Blueprints 0.5
- Many bugs fixed

Full list: http://code.google.com/p/orient/issues/list?can=1&q=label:v0.9.25

-------------------------------------------------------------------------------
VERSION 0.9.24 - (December, 10th 2010)
-------------------------------------------------------------------------------
New features:
- Support for Clustering with synchronous and asynchronous replication
- New SQL RANGE keyword: SELECT FROM ... WHERE ... RANGE <from> [,<to>]
- New SQL LIMIT keyword: SELECT FROM ... WHERE ... LIMIT 20
- Improved CREATE INDEX command
- New REMOVE INDEX command
- New console command INFO CLASS
- New console command TRUNCATE CLASS and TRUNCATE CLUSTER
- MRB+Tree now is faster and stable
- Improved import/export commands
- Improved JSON compliance
- Improved TRAVERSE operator with the optional field list to traverse
- Fixed a lot of bugs

For the complete list:
http://code.google.com/p/orient/issues/list?can=1&q=label:v0.9.24

-------------------------------------------------------------------------------
VERSION 0.9.23 - (October, 18th 2010)
-------------------------------------------------------------------------------
New features:
- Issue  92: Support for logical cluster in TX
- Issue 125: Cross-domain access to the DB server for Silverlight and Flash
             clients
Bugs:
- Issue  65: Slow query on Index when the value isn't in the database
- Issue  73: OrientDB Studio issues
- Issue  83: ClassCastException occurs
- Issue  99: Deleting docs one by one will cause exception
- Issue 110: ClassCastException occurs in OrientDB Studio
- Issue 113: RegisterEntityClasses once with ODatabaseObjectPool should be
             enough
- Issue 115: Concurrent access fails various ways and performance is bad
- Issue 116: Referenced POJOs are not stored during save
- Issue 117: TreeMap performance degrades under high load
- Issue 118: Registering classes should use fully qualified class name, not
             strings
- Issue 119: Error occurs call OSQLQuery method with the query string that
             starts with white space.
- Issue 121: Debug option in base-build.xml
- Issue 122: An error has occurred while building the revision 1465
- Issue 131: REST api record update requires to repeat all attributes
- Issue 132: Error 500 on curl POST to REST api
- Issue 133: REST api: cannot change record class?
- Issue 135: Stacktrace contradiction, Type BINARY must be a collection
- Fixed other minor bugs

-------------------------------------------------------------------------------
VERSION 0.9.22 - (September, 15th 2010)
-------------------------------------------------------------------------------
New features:
- Issue  21: Full text index against schema fields
- Issue  91: SQL UPDATE against collections and maps
- Issue  94: Support for GREMLIN graph language
- Issue 108: Regular expression support in WHERE clause
- Issue 109: Support for memory clusters inside regular persistent database

Bugs:
- Issue  86: Cannot insert record from console
- Issue  87: Cannot query records from OrientDB Studio Command-page
- Issue 100: Transaction does not work as expected
- Issue 101: Error in using orient queries having ' character
- Issue 104: Bulk record creation in cluster with pre-created indices causes
             ClassCastException
- Issue 105: Error in using UPDATE query
- Fixed other minor bugs

-------------------------------------------------------------------------------
VERSION 0.9.21 - (July, 29th 2010)
-------------------------------------------------------------------------------
- Issue 60: GraphDB implementation
- Issue 8:  Import of exported database
- Issue 70: Connection pool
- Issue 67: Support lazy loaded collections and maps also for ODocument
- Issue 66: Optimize loading of database schema at opening using the fetch plan
- Issue 71: Support record internal field in queries
- Issue 63: Server: logs by default should reside in files
- Issue 69: Java 1.6 creep
- Issue 74: Create class from console
- Issue 75: Sequential document updates from different connections yields
            conncurrent modification exception
- Issue 78: Database corruption
- Issue 79: Error parsing example query
- Issue 80: Root cause not reported on query parsing
- New annotations to control object mapping: ORawBinding, ODocumentId and
  ODocumentInstance
- Fixed other minor bugs

-------------------------------------------------------------------------------
VERSION 0.9.20 - (July, 12nd 2010)
-------------------------------------------------------------------------------
- New run-time Fetch Plans. Example: "parent:0 Address.city:1 *:-1" (Issue #54)
- New database properties (Issue #54)
- POJO callback on serialization/deserialization (Issue #56)
- New annotation to use RAW binding (Issue #57)
- Enhance the base-build.xml to create all required directories (Issue #58)
- Fixed object graph management
- Fixed other minor bugs

-------------------------------------------------------------------------------
VERSION 0.9.19 - beta (June, 25th 2010)
-------------------------------------------------------------------------------
- Issue #10: support for native inheritance between Documents and POJOs
- Issue #45: implemented not-unique indexes
- Issue #47: support ORDER BY clause in SQL SELECT statements
- Issue #53: Improved description on errors 
- Issue #50: Auto register Remote Engine if available
- Fixed other bugs (user loading, logical cluster casts)
-------------------------------------------------------------------------------
VERSION 0.9.18 - beta (June, 21st 2010)
-------------------------------------------------------------------------------
- New SQL command "create link" to create physical connection between records.
  Useful when import a Relational DBMS. Use the "inverse" form to map 1-N
  relationships
- New console command "import documents" to import JSON document 
- New SQL command "create property" to add schema full properties
- Added status in OUser and checked when login. By default is ACTIVE
- Issue #44: support of ORID in queries. Example: SELECT FROM profile WHERE
             friends IN [10:3, 10:1]
- Fixed other bugs (not null, not equals, encoding)

-------------------------------------------------------------------------------
VERSION 0.9.17 - beta (June, 7th 2010)
-------------------------------------------------------------------------------
- New Index API to create a unique index for each property. This speed up the
  performance of queries but slow down updates, inserts and deletes
- OrientDB Studio: new rendering for links
- Fixed bug on embedded type in collections

-------------------------------------------------------------------------------
VERSION 0.9.16 - beta (May, 31st 2010)
-------------------------------------------------------------------------------
- New Hook API. Like triggers of RDBMS but call Java app code
- Fixed all the bugs reported by the user in the last weeks (schema and
  serialization)

-------------------------------------------------------------------------------
VERSION 0.9.15 - beta (May, 27th 2010)
-------------------------------------------------------------------------------
- New management of users and roles
- New SQL commands: GRANT and REVOKE to manage permissions
- Enforced security in OrientDB Server with the support of Server users. The
  Server administrator account is created at first start of the Server with
  a random password
- Fixed minor issues
- Changed *.config files to *.xml

-------------------------------------------------------------------------------
VERSION 0.9.14 - beta (May, 21st 2010)
-------------------------------------------------------------------------------
- New Database structure. Logical clusters now are well integrated at storage
  level
- Improved OrientDB Studio with authentication, user, roles, clusters,
  db and server properties, etc.
- New User and Role management
- More flexible management of types in ODocument instances
- Supported HTTP Authentication basic
- Fixed some bugs in concurrency with high number of clients

-------------------------------------------------------------------------------
VERSION 0.9.13 - beta (May, 10th 2010)
-------------------------------------------------------------------------------
- New HTTP RESTful interface to the OrientDB Server
- New OrientDB Server Studio GUI to manage documents, requests and monitor the
  active connections. It's 100% web client-side
  application built with HTML, CSS and JQuery
- Fixed minor bugs on http-connections

-------------------------------------------------------------------------------
VERSION 0.9.12 (beta) - beta (May, 5th 2010)
-------------------------------------------------------------------------------
- Full support to asynchronous remote command execution. Now only SQL has been
  implemented (select, insert, update, delete)
- Fixed bug on LIKE operator
- Improved JMX monitoring support for OrientDB Server: active sessions,
  configured handlers and protocols, status, etc.
- Changed the default OrientDB Server port to 2424 and for OrientKV Server has
  been assigned the 2431.

-------------------------------------------------------------------------------
VERSION 0.9.11 (beta) - beta (April, 28th 2010)
-------------------------------------------------------------------------------
- New support for SQL commands INSERT, UPDATE and DELETE. Now everybody that
  knows SQL can start using OrientDB without the need to learn a complex syntax
  or, at worst, a Map/Reduce!

-------------------------------------------------------------------------------
VERSION 0.9.10 (beta) - beta (April, 24th 2010)
-------------------------------------------------------------------------------
- Operator traverse now accepts optional parameters to limit deep of
  recursivity: traverse(minDeep, maxDeep)
- any() and all() can accept chain of field operators such. Example:
  select from Profile where any() traverse(0,3) (any().indexOf( 'Navona' ) >-1)
- Orient Server loads any db placed in $ORIENT_HOME/databases directory without
  the need to configure them
- Memory databases can be used and shared on any Orient Server instances."temp"
  is the memory database pre-configured by default

-------------------------------------------------------------------------------
VERSION 0.9.9 (beta) - beta (April, 21st 2010)
-------------------------------------------------------------------------------
- Refactored SQL query engine to support external custom operators
- Improved POJO <-> ODocument conversion and performance
- New operators in test: any(), all() and traverse()
- Migrated demo database from petshop to demo with a Twitter-like app called
  "Whiz", specially useful to test traverse of graphs
- Implemented constraints on date (min/max)
- Fixed bug on circular references problem
- New Lazy-loaded list of pojo from ODocument converted only upon request

-------------------------------------------------------------------------------
VERSION 0.9.8 (beta) - beta (April, 18th 2010)
-------------------------------------------------------------------------------
- Fixed issue #20 (http://code.google.com/p/orient/issues/detail?id=20)
- Minor refactoring to support partitioning in Key/Value Server

-------------------------------------------------------------------------------
VERSION 0.9.7 (beta) - beta (April, 14th 2010)
-------------------------------------------------------------------------------
- Fixed problem on 'create database' and 'create cluster' console commands.
- Removed buggy 'create record' command in favor of new SQL 'insert' available
  in the next days

-------------------------------------------------------------------------------
VERSION 0.9.6 (beta) - beta (April, 12nd 2010)
-------------------------------------------------------------------------------
- Splitted Orient release in two: Database and Key/Value Server. Starting from
  now the Key/Value Server is distributed separately

-------------------------------------------------------------------------------
VERSION 0.9.5 (beta) - beta (April, 9th 2010)
-------------------------------------------------------------------------------
- Improved the speed of Key/Value Server +35%
- New console commands: get, set, properties, browse class, browse cluster,
                        export record
- The console now is able to display any kind of record
- New method ODocument.toJSON() that export in JSON format

-------------------------------------------------------------------------------
VERSION 0.9.4 (beta) - beta (April, 8th 2010)
-------------------------------------------------------------------------------
- Fixed bug on Key/Value Server in HTTP protocol parsing
- New benchmarks folder to test performance of the Key/Value Server
- Renamed many classes to the final names

-------------------------------------------------------------------------------
VERSION 0.9.3 (beta) - beta (April, 6th 2010)
-------------------------------------------------------------------------------
- Added new console commands:
  - dictionary keys
  - dictionary get
  - dictionary put
  - load record
  - display record
- Fixed minor bug on serialization

-------------------------------------------------------------------------------
VERSION 0.9.2 (beta) - beta (April, 2nd 2010)
-------------------------------------------------------------------------------
First public release created by the knowledge acquired by Orient ODBMS. The new
engine was totally rewritten in Java (before it was in C++) with a lot of
improvement and new functionalities.

